package com.prismt.cos.CosNaming.examples;


import javax.naming.*;
import javax.naming.spi.*;
import java.util.*;


public class JNDI
{
   public static void main (String[] args)
   {
      Context rootctx = null;
      Context subctx = null;

      // Create a hashtable for the environment
      Hashtable env = new Hashtable ();

      // Use file based persistence
      env.put
         ("com.prismt.j2ee.jndi.OpenFusionSPI.JDBC.URL", "jdbc:hsqldb:/tmp");
      // Use a read cache.
      env.put ("com.prismt.j2ee.jndi.OpenFusionSPI.ReadCache", "100");
      // Set the UUID.
      env.put
      (
         "com.prismt.j2ee.jndi.OpenFusionSPI.UUID",
         "8e82d2c0-1d04-11d4-844f-a0b231700aae"
      );

      // Set inital context
      env.put
      (
         javax.naming.Context.INITIAL_CONTEXT_FACTORY,
         "com.prismt.j2ee.jndi.OpenFusionCtxFactory"
      );

      try
      {
         // Get the root context
         rootctx = NamingManager.getInitialContext (env);
      }
      catch (NamingException e)
      {
         System.err.println ("Caught: " + e);
      }


      try
      {
         // Note the quoting that needs to be done in order for both the INS
         // and the JNDI name schemes to work together.
         Context resolved  = (Context)rootctx.lookup ("\"A\\.\\/B\"");
         System.out.println ("Resolved: " + resolved);
      }
      catch (NamingException e)
      {
         System.err.println ("Correctly caught: " + e);
      }

      try
      {
         System.out.println ("Creating subcontext");
         subctx = rootctx.createSubcontext ("\"A\\.\\/B\"");

         System.out.println ("Subctx: " + subctx);
         subctx.close ();
      }
      catch (NamingException e)
      {
         System.err.println ("Caught: " + e);
      }

      try
      {
         String strname = "A\\.\\/B";
         NameParser parser = rootctx.getNameParser ("");
         Name jndiname = parser.parse (strname);

         subctx = (Context)rootctx.lookup (jndiname);

         System.out.println ("Resolved: " + subctx);
      }
      catch (NamingException e)
      {
         System.err.println ("Caught: " + e);
      }


      try
      {
         String strname = "A\\.\\/B";

         com.prismt.cos.CosNaming.OFNamingConverter of =
            (new com.prismt.cos.CosNaming.OFNamingConverter ());

         subctx = (Context)rootctx.lookup (of.convertCOStoJNDI (strname));

         System.out.println ("Resolved: " + subctx);
      }
      catch (NamingException e)
      {
         System.err.println ("Caught: " + e);
      }
   }
}
