/*************************************************************************
 *                           - COPYRIGHT NOTICE -                        *
 *                                                                       *
 * The information contained herein and which follows is proprietary     *
 * information and is the property of PrismTech Corporation.  This       *
 * information is not to be divulged, released, copied, reproduced, or   *
 * conveyed to unauthorized personnel, companies, or other institutions  *
 * without the direct and expressed approval in writing of PrismTech     *
 * Corporation.                                                          *
 *                                                                       *
 *                                                                       *
 *                           - DISCLAIMER -                              *
 * Neither PrismTech Limited nor PrismTech Corporation ("PrismTech")     *
 * are under any obligation to support the use of this code which is     *
 * provided without warranty of any kind. PrismTech shall (except as     *
 * otherwise prohibited by law) have no liability whatsoever in relation *
 * to its use.                                                           *
 *                                                                       *
 ************************************************************************/

/**
 * @author PrismTech
 * @version Version 1.0
 */

package com.prismt.cos.CosNaming.examples.Video;

/**
 * <code>FilmImpl</code> represents a Film.
 *
 */
public class FilmImpl
   implements com.prismt.openfusion.examples.Video.FilmOperations
{
   private String filmTitle       = null;
   private String filmDescription = null;
   private String filmCertificate = null;

   /**
    * <code>FilmImpl</code> creates a new Film instance..
    *
    * @param description a <code>String</code> value
    * @param certificate a <code>String</code> value
    */
   public FilmImpl (String description, String certificate)
   {
      filmTitle = "Unknown";
      filmDescription = description;
      filmCertificate = certificate;
   }

   /**
    * <code>certificate</code> returns the rating of the film.
    *
    * @return a <code>String</code> value
    */
   public String certificate ()
   {
      return filmCertificate;
   }

   /**
    * <code>description</code> returns the description of the film.
    *
    * @return a <code>String</code> value
    */
   public String description ()
   {
      return filmDescription;
   }

   /**
    * <code>title</code> returns the title of the film.
    *
    * @return a <code>String</code> value
    */
   public String title ()
   {
      return filmTitle;
   }

   /**
    * <code>show</code> starts the programme.
    *
    */
   public void show ()
   {
      // Not required for this implementation.
   }
}
