/*************************************************************************
 *                           - COPYRIGHT NOTICE -                        *
 *                                                                       *
 * The information contained herein and which follows is proprietary     *
 * information and is the property of PrismTech Corporation.  This       *
 * information is not to be divulged, released, copied, reproduced, or   *
 * conveyed to unauthorized personnel, companies, or other institutions  *
 * without the direct and expressed approval in writing of PrismTech     *
 * Corporation.                                                          *
 *                                                                       *
 *                                                                       *
 *                           - DISCLAIMER -                              *
 * Neither PrismTech Limited nor PrismTech Corporation ("PrismTech")     *
 * are under any obligation to support the use of this code which is     *
 * provided without warranty of any kind. PrismTech shall (except as     *
 * otherwise prohibited by law) have no liability whatsoever in relation *
 * to its use.                                                           *
 *                                                                       *
 ************************************************************************/

/**
 * @author PrismTech
 * @version Version 1.0
 */

package com.prismt.cos.CosNotification.examples.Benchmark;


/**
 * The base class for all benchmark consumers.
 */
abstract public class BenchmarkConsumer extends BenchmarkBaseClient
{
   /**
    * The number of events received.
    */
   protected int eventsReceived = 0;


   /**
    * Returns the number of events received by the consumer.
    * @return The number of events received.
    */
   public int getEventsReceived ()
   {
      return eventsReceived;
   }


   /**
    * Resets the count of events received by the consumer.
    */
   public void resetEventsReceived ()
   {
      eventsReceived = 0;
   }
}


// EOF
