/*************************************************************************
 *                           - COPYRIGHT NOTICE -                        *
 *                                                                       *
 * The information contained herein and which follows is proprietary     *
 * information and is the property of PrismTech Corporation.  This       *
 * information is not to be divulged, released, copied, reproduced, or   *
 * conveyed to unauthorized personnel, companies, or other institutions  *
 * without the direct and expressed approval in writing of PrismTech     *
 * Corporation.                                                          *
 *                                                                       *
 *                                                                       *
 *                           - DISCLAIMER -                              *
 * Neither PrismTech Limited nor PrismTech Corporation ("PrismTech")     *
 * are under any obligation to support the use of this code which is     *
 * provided without warranty of any kind. PrismTech shall (except as     *
 * otherwise prohibited by law) have no liability whatsoever in relation *
 * to its use.                                                           *
 *                                                                       *
 ************************************************************************/

/**
 * @author PrismTech
 * @version Version 1.0
 */

package com.prismt.cos.CosTrading.examples.Video;

/**
 * An implementation of the <code>SportsEvent</code> interface.
 */

public class SportsEventImpl
   implements com.prismt.openfusion.examples.Video.SportsEventOperations
{
   String sportsTitle = null;
   String sportsType = null;
   VideoMachine machine = null;
   private org.omg.CORBA.Object object = null;

   /**
    * @param <code>title</code> The title of the sports event.
    * @param <code>certificate</code> The sport.
    * @param <code>vm</code> The video machine which shows the sports event.
    */
   public SportsEventImpl (String title, String sport, VideoMachine vm)
   {
      sportsTitle = title;
      sportsType = sport;
      machine = vm;
   }

   /**
    * Show the sports event (ie print a message)
    */
   public void show ()
   {
      machine.withdraw ();
      System.out.println ("Showing the sports event: " + title ());
      machine.export ();
   }

   /**
    * Return the sports event's title
    *
    * @return The title of the sports event.
    */
   public String title ()
   {
      return sportsTitle;
   }

   /**
    * Return the sport
    *
    * @return The sport.
    */
   public String sport ()
   {
      return sportsType;
   }

   /**
    * Return the sports event's description. This is the combination of title
    * and sport.
    *
    * @return The description of the film.
    */
   public String description ()
   {
      return (sportsType + ": " + sportsTitle);
   }
}
