package org.jacorb.util;

/*
 *        JacORB  - a free Java ORB
 *
 *   Copyright (C) 1997-2004  Gerald Brose.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Library General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Library General Public License for more details.
 *
 *   You should have received a copy of the GNU Library General Public
 *   License along with this library; if not, write to the Free
 *   Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

import java.util.*;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.BufferedReader;
import java.net.URL;


/**
 * @author Gerald Brose, FU Berlin
 * @version $Id: ObjectUtil.java,v 1.3 2004/08/19 15:13:52 rnc Exp $
 */

public class ObjectUtil
{
    /**
     * @return the contents of the resource as a string, or null
     * if the contents of the resource could not be located using url
     */
    public static final String readURL( String url )
    {
        InputStreamReader isr = null;
        BufferedReader in = null;
        String line = "";

        if (url.startsWith ("file://"))
        {
            try
            {
                // Substring is file:// token length
                isr = new java.io.FileReader (url.substring(7));
            }
            catch (FileNotFoundException e)
            {
                if (Debug.isDebugEnabled())
                {
                    Debug.output("Tried and failed to open file: " + url.substring(7));
                }
                // no worries, let the URL handle it
            }
        }
        try
        {
            if (isr == null)
            {
                isr = new java.io.InputStreamReader((new URL(url)).openStream());
            }

            in = new java.io.BufferedReader (isr);
            line = in.readLine();
            in.close();

            return line;
        }
        catch ( IOException e )
        {
            if (Debug.isDebugEnabled())
            {
                Debug.output("Problem reading URL; caught a " + e);
            }
        }
        return null;
    }

}
