package org.jacorb.test.idl;

/*
 *        JacORB  - a free Java ORB
 *
 *   Copyright (C) 1997-2001  Gerald Brose.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Library General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Library General Public License for more details.
 *
 *   You should have received a copy of the GNU Library General Public
 *   License along with this library; if not, write to the Free
 *   Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

import junit.framework.*;
import junit.extensions.TestSetup;
import org.jacorb.idl.ParseException;
import java.io.File;


/**
 * AMI.java
 *
 * IDL parse with ami_callback tests.
 *
 */

public class AMITest extends TestCase
{
   public AMITest (String name)
   {
      super (name);
   }


   public static Test suite ()
   {
      TestSuite suite = new TestSuite ("AMI Tests");
      suite.addTest (new AMITest ("testAMIParseGood1"));
      suite.addTest (new AMITest ("testAMIParseGood2"));

      return suite;
   }


   /**
    */
   public void testAMIParseGood1 ()
   {
      StringBuffer command = new StringBuffer ();
      String file[] = new String[4];
      file[0] = "-d";
      file[1] = ((String)System.getProperty ("testdir")).concat ("/src/generated");
      file[2] = "-ami_callback";
      file[3] = ((String)System.getProperty ("testdir")).concat ("/idl/compiler/succeed/ReplyHandler.idl");

      assertTrue ("Compiled ReplyHandler.idl", org.jacorb.idl.parser.compileAndHandle (file));
   }

   public void testAMIParseGood2 ()
   {
      StringBuffer command = new StringBuffer ();
      String file[] = new String[5];
      file[0] = "-d";
      file[1] = ((String)System.getProperty ("testdir")).concat ("/src/generated");
      file[2] = "-I" + (String)System.getProperty ("testdir") + "/../../idl/omg";
      file[3] = "-ami_callback";
      file[4] = ((String)System.getProperty ("testdir")).concat ("/idl/compiler/succeed/AMIInc.idl");

      assertTrue ("Compiled AMIInc.idl", org.jacorb.idl.parser.compileAndHandle (file));
   }
}
