
/* Common Tables */

CREATE CACHED TABLE OF_Servers
(
   SIDIndex INTEGER NOT NULL, /* server id index */
   SID CHAR(36) NOT NULL, /* server id uuid string */
   PRIMARY KEY (SID)
)
;

CREATE CACHED TABLE OF_Names
(
   Name VARCHAR NOT NULL, /* name string */
   NameHash INTEGER NOT NULL, /* name hash value */
   NameIndex INTEGER NOT NULL, /* name index */
   PRIMARY KEY (NameIndex)
)
;

CREATE CACHED TABLE OF_Objects
(
   OID CHAR(36) NOT NULL, /* object id uuid string */
   PIDIndex INTEGER NOT NULL, /* process id index */
   TStamp TIMESTAMP NOT NULL, /* update timestamp */
   Data BINARY NOT NULL, /* serialized object state */
   PRIMARY KEY (OID)
)
;
