-- Common Tables

CREATE TABLE OF_Servers
(
   SIDIndex INT8 NOT NULL,
   SID CHAR(36) NOT NULL,
   PRIMARY KEY (SID)
)
;

CREATE TABLE OF_Names
(
   Name LVARCHAR NOT NULL,
   NameHash INT8 NOT NULL,
   NameIndex INT8 NOT NULL,
   PRIMARY KEY (NameIndex)
)
;

CREATE TABLE OF_Objects
(
   OID CHAR(36) NOT NULL,
   PIDIndex INT8 NOT NULL,
   TStamp DATETIME YEAR TO FRACTION(5) NOT NULL,
   Data BYTE NOT NULL,
   PRIMARY KEY (OID)
)
;

-- Procedure to find existing or create new process index
-- NOT USED: Informix does not support out parameters.

-- Procedure to delete an object

CREATE PROCEDURE of_delete_object (id CHAR(36))
   DELETE FROM OF_Objects WHERE OID = id;
END PROCEDURE
;

-- Procedure to delete objects

CREATE PROCEDURE of_delete_objects (pid INT8)
   DELETE FROM OF_Objects WHERE PIDIndex = pid;
END PROCEDURE
;

-- Procedure to check whether an object exists
-- NOT USED: Informix does not support out parameters.
