package org.jacorb.imrutility.imr;

import java.io.Serializable;

/**
 * Holds details for a Server.  Used to store details in memory
 * and persistence
 */
public class ServerRecord implements Serializable
{
    /** The IOR of the Server */
    String srv;

    /** 
     * The impl type name key associated with this server.  The impl
     * type name key will consist only of an impl name or only of 
     * POA names but not both.  
     */
    POANameKey pnKey;
    
    /** 
     * Constructor
     * @param <code>in_srv</code> the Servers IOR
     * @param <code>in_key</code> the impl type name key associated with this 
     * server
     */
    public ServerRecord(String in_srv, POANameKey in_key)
    {
        srv = in_srv;
        pnKey = in_key;
    }
}
