package org.jacorb.imrutility.imr.policy;

import org.jacorb.imrutility.imr.LoadBalancingPolicy;

import java.util.HashMap;
import java.util.TreeMap;

/**
 * @author cj
 *
 * This class applies the First In First Out load balancing policy.
 * It returns the active server that was the earliest registered 
 */
public class FIFO implements LBPolicy
{
    /**
     * Returns the unique id for the FIFO policy
     */
    public int policy()
    {
        return LoadBalancingPolicy._FIFO;
    }

    /**
     * This method returns the first registered server A <code>TreeMap</code> 
     * is used as this keeps the data in the order entered e.g. the first 
     * registered server will be the first entry, the last registered server 
     * will be the last entry.
     * @param name the implementation  name - not used by all policies.
     * @param servers a Map containing the time the server was registered as 
     * the key and the Server ID
     */   
    public HashMap getSelectedServer (String name, TreeMap servers)
    {       
        HashMap selected = new HashMap();
        selected.put(servers.firstKey(), servers.get(servers.firstKey()));
        return selected;
    }
}
