package org.jacorb.imrutility.imr.util;

/**
 * @author cj
 *
 * When a request is received by the <code>MulticastServer</code> a <code>
 * MulticastEvent</code> is created to store the data received with the request.
 * The <code>MulticastEvent</code> is then passed to any listeners. 
 */
public class MulticastEvent 
{
   /* The data received with the request*/
   private byte [] data = null;
   
   /**
    *  Constructor
    * @param data the data received with the request
    */
   public MulticastEvent (byte [] data)
   {
      this.data = data;   
   }  
   
   /**
    * @return data the data received with the request
    */
   public byte [] getData()
   {
      return data;
   } 

}
